﻿
Public Class FTestDataGrid

    Dim CuantidadColumna As Integer
    Dim CuantidadLinea As Integer

    Private Sub FBase_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        MiDGV.AllowUserToAddRows = False
        MiDGV.AllowUserToDeleteRows = False
        MiDGV.AllowUserToOrderColumns = False
        MiDGV.RowHeadersVisible = False 'Visible
        MiDGV.TopLeftHeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        MiDGV.RowHeadersWidthSizeMode = DataGridViewRowHeadersWidthSizeMode.AutoSizeToAllHeaders '.AutoSizeToFirstHeader
        MiDGV.MultiSelect = True

    End Sub

    Private Sub CrearDGV()
        Dim NombreCol As String
        Dim TextoHeader As String
        CuantidadColumna = 6
        For C As Integer = 0 To CuantidadColumna - 1    ' CuantidadColumna es escribido en Fomr_Load
            Select Case C
                Case 0
                    NombreCol = "Meses"
                    TextoHeader = "Meses"
                Case 1
                    NombreCol = "CapIni"
                    TextoHeader = "Cap. Inicial"
                Case 2
                    NombreCol = "Interes"
                    TextoHeader = "Interes"
                Case 3
                    NombreCol = "Cuota"
                    TextoHeader = "Cuota"
                Case 4
                    NombreCol = "Abono"
                    TextoHeader = "Abono Cap."
                Case 5
                    NombreCol = "CapFin"
                    TextoHeader = "Cap. Final"
            End Select

            MiDGV.Columns.Add(NombreCol, TextoHeader)
            MiDGV.Columns(NombreCol).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleRight
            MiDGV.Columns(NombreCol).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight
        Next
        CuantidadLinea = TBCuantidadMeses.Text
        For R As Integer = 0 To CuantidadLinea - 1  ' CuantidadLinea es escribido en Fomr_Load
            ''    TextoHeader = R + 1 ' Aqui, crear el texto del RowHeader
            MiDGV.Rows.Add()
            ''    MiDGV.Rows(R).HeaderCell.Value = TextoHeader
        Next

        MiDGV.TopLeftHeaderCell.Value = ""   ' Solo si tienes que escribir en este celda

    End Sub

    Private Sub BLlenar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BLlenar.Click
        MiDGV.Columns.Clear()
        MiDGV.Rows.Clear()
        CrearDGV()

        If TBCapitalInicial.Text = String.Empty Or
            TBCuantidadMeses.Text = String.Empty Or
            TBCuantidadMeses.Text = String.Empty Then
            MessageBox.Show("Tienes que introducir todos los datos !")
            Exit Sub
        End If

        Dim PLazo As Double = CType(TBCuantidadMeses.Text, Double)
        Dim CapitalIni As Double = CType(TBCapitalInicial.Text, Double)
        Dim TasaAnual As Double = CType(TBTasaAnual.Text, Double)
        Dim Interes As Double
        Dim Cuota As Double
        Dim AbonoCap As Double
        Dim CapitalFin As Double = CType(TBCapitalInicial.Text, Double)

        Dim TasaMensual As Double

        TasaMensual = TasaAnual / 12
        Cuota = (TasaMensual / 100 * CapitalIni) / (1 - ((1 + TasaMensual / 100) ^ (-1 * PLazo)))

        '   For C As Integer = 0 To CuantidadColumna - 1     ' CuantidadColumna es escribido en Fomr_Load
        For R As Integer = 0 To CuantidadLinea - 1    ' CuantidadLinea es escribido en Fomr_Load

            Interes = CapitalIni / 100 * TasaMensual
  
            AbonoCap = Cuota - Interes
            CapitalFin = CapitalIni - AbonoCap
  
            MiDGV.Item(0, R).Value = R + 1   ' Meses
            MiDGV.Item(1, R).Value = String.Format("{0:##0.00}", CapitalIni)
            MiDGV.Item(2, R).Value = String.Format("{0:##0.00}", Interes)
            MiDGV.Item(3, R).Value = String.Format("{0:##0.00}", Cuota)
            MiDGV.Item(4, R).Value = String.Format("{0:##0.00}", AbonoCap)
            MiDGV.Item(5, R).Value = String.Format("{0:##0.00}", CapitalFin)

            CapitalIni = CapitalFin

            '  MiDGV.Item(C, R).Value = (C + 1) * 100 + R + 1  ' Aqui, llenar la celda con su valor, puede ser una funcion que da la valor

        Next R
        '     Next C

        Totalizacion()

    End Sub

    Private Sub Totalizacion()
        If MiDGV.Rows.Count < 1 Then Exit Sub

        Dim R As Integer

        MiDGV.Rows.Add()
        R = MiDGV.Rows.Count - 1
        MiDGV.Item(0, R).Value = "Total"
        MiDGV.Item(1, R).Value = ""
        MiDGV.Item(5, R).Value = ""

        Dim Interes As Double = 0
        Dim Cuota As Double = 0
        Dim AbonoCap As Double = 0

        For R = 0 To MiDGV.Rows.Count - 1
            Interes += CType(MiDGV.Item(2, R).Value, Double)
            Cuota += CType(MiDGV.Item(3, R).Value, Double)
            AbonoCap += CType(MiDGV.Item(4, R).Value, Double)
        Next

        MiDGV.Item(2, R - 1).Value = String.Format("{0:##0.00}", Interes)
        MiDGV.Item(3, R - 1).Value = String.Format("{0:##0.00}", Cuota)
        MiDGV.Item(4, R - 1).Value = String.Format("{0:##0.00}", AbonoCap)
    End Sub

    Private Sub BLimpiar_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles BLimpiar.Click
        MiDGV.Columns.Clear()
        MiDGV.Rows.Clear()
    End Sub
End Class

